﻿/*
 * LCD.c
 *
 * Created:	12/12/2015 2:11:56 am
 * Author:	Dimitrios Porlidas
 */ 

#include "LCD_keyb.h"

uint8_t out;
uint8_t lg1;

//				 L1R1  2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20 L3R1  2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20
//				 L2R1  2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20 L4R1  2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20
uint8_t logo[] = {'D','i','m','i','t','r','i','o','s',' ','P','o','r','l','i','d','a','s',' ',' ','A','V','R',' ','P','r','o','j','e','c','t','s',' ',' ',' ',' ',' ',' ',' ',' ',
				  'w','w','w','.','p','o','r','l','i','d','a','s','.','g','r',' ',' ',' ',' ',' ','P','r','e','s','s',' ','C',' ','t','o',' ','c','l','e','a','r',' ',' ',' ',' '};

void WrIn (uint8_t tmp)										// Write Instruction routine
{
	out = tmp & 0b11110000;									// Upper
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (100);
	out = tmp << 4;											// Lower
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (50);
}

void WrDa (uint8_t tmp)										// Write Data routine
{
	out = tmp & 0b11110000;									// Upper
	lcdport = (out | Da);
	_delay_us (100);
	lcdport = (out | En | Da);
	_delay_us (100);
	lcdport = (out | Da);
	_delay_us (100);
	out = tmp << 4;											// Lower
	lcdport = (out | Da);
	_delay_us (100);
	lcdport = (out | En | Da);
	_delay_us (100);
	lcdport = (out | Da);
	_delay_us (50);
}

void SeCu (uint8_t addr)									// Send cursor to a specific address (0-80)
{
	WrIn (0b10000000 | addr);
}

void SeCG (uint8_t addr)									// Set CGRAM address
{
	WrIn (0b01000000 | addr);
}

void TypeLogo (uint8_t logo2[])								// Logo routine
{
	for (lg1 = 0; lg1 < 80; lg1++)							// Send logo
	WrDa (logo2[lg1]);
}

void TypeMainLogo (void)									// Main Logo routine
{
	for (lg1 = 0; lg1 < 79; lg1++)							// Send logo
	WrDa (logo[lg1]);
}

void InitLCD (void)											// Start up, initialization rutine
{
	lcdport = 0;
	out = 0b00110000;
	_delay_ms (20);											// Power on delay 20ms
	
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_ms (5);
	
	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_us (200);

	lcdport = (out | En);									// Init
	_delay_us (100);
	lcdport = out;
	_delay_ms (5);

	out = 0b00100000;										// 4 bit interface
	lcdport = out;
	_delay_us (100);
	lcdport = (out | En);
	_delay_us (100);
	lcdport = out;
	_delay_us (50);

	WrIn (0b00101100);										// 001, 4 bit, 2 lines 2x16 (4 lines 4x20), 5x11 dots (LCD),xx

	WrIn (0b00001111);										// 00001, Display on, cursor on, blinking on (LCD)

	WrIn (0b00000110);										// 000001, Cursor increase, display not shift (LCD)

	WrIn (CDRC);											// Clear display, reset cursor (LCD)
	_delay_ms (2);
	
	TypeMainLogo ();
	
	//	TypeLogo (logo);
}
