/*
 * main.c
 *
 * Created: 12/12/2015 1:35:06 am
 * Author:	Dimitrios Porlidas
 *
 * Master
 *
 */ 

#include "LCD_keyb.h"

#define ACK 0xAA											// Slave acknowledgment

uint8_t Sdata;												// SPI data register

void SPI_MasterInit(void)									// Initialize SPI Master
{
												
	DDRB = ((1<<4)|(1<<5)|(1<<7));							// Set SS MOSI and SCK output, all others input
	SPCR = ((1<<SPE)|(1<<MSTR)|(1<<SPR0));					// Enable SPI, Master, set clock rate fosc/16
	PORTB |= (1<<6);										// Enable pull up resistor in MISO
}

uint8_t SPI_Transceiver (uint8_t Sdata)
{
	SPDR = Sdata;											// Load data into the buffer
	while(!(SPSR & (1<<SPIF) ));							// Wait until transmission complete
	return(SPDR);											// Return received data
}

int main(void)
{
//	lcdddr = 0b11111110;									// LCD PORTx0 input (for DAC), PORTx1:7 outputs (LCD)
	keyddr = 0b00001111;									// Keyboard PORTx4:7 inputs (columns), PORTx0:3 outputs (rows)
//	lcdport = 0b11111111;									// Enable pull up resistors on inputs, send 1 to outputs (keyboard)
	DDRC = (1<<0);											// LED Blinks in every cycle
	PORTC = (1<<0);
	
//	InitLCD ();												// Initialize LCD 16x2 or 20x4

	SPI_MasterInit();										// Initialize SPI Master

    while (1) 
    {
		Keyb ();											// Check keyboard
		if (bit_is_set(entry,0))							// If button pressed
		{
			Sdata = SPI_Transceiver(data);					// Transmite data
			entry &= (0<<0);								// Clear entry flag
		}
		PORTC = ~PORTC;										// LED Blinks in every cycle
		_delay_ms(25);
    }
}

